<%--
 * Component: prior
 *
 * Description:
 *  Gets prior studies for a study from the Archive or QR device.
 *
 * Parameters:
 *
 *   cStudy          Study Instance UID of studies to be retrieved
 *   cBack           Back URL
 *
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%@
	page import="java.util.Properties, java.util.Enumeration,
			imagemed.exception.*, imagemed.imsession.*, imagemed.jsputil.*, imagemed.taskd.IMScriptContext"

%><%-- Some setup --%><%
	IMSession is = new IMSession(request, response, out);

	String parStudies[] = request.getParameterValues("cStudy");
	String parBack      = request.getParameter("cBack");
	if (parBack == null) {
		parBack = request.getHeader("REFERER");
	}
	String tabPage = "cases/index.jsp";

	if (parStudies == null) {
		throw new IMGeneralException( "No studies selected for retrieval!", tabPage, "Correction Error", parBack);
	}
	// In case of timeout go back to index.jsp
	is.regDest = request.getParameter("reg_dest");
	if (is.regDest == null) {
		is.regDest = parBack;
	}
	if (!is.regOK()) {
		return;
	}
%>
<HTML><head>
<%	imagemed.http.tabs.TabBean.writeStyleOnly(is);
 %>
</head>
<body onLoad="top.location='<%=parBack%>'">
<%

	Properties archiveStudies = new Properties();
	for ( int i = 0 ; i < parStudies.length ; i++ ) {
		boolean isIMArchive = parStudies[i].startsWith("a_");
		if (!isIMArchive && !parStudies[i].startsWith("q_")) {
			// Retrieve from unknown archive
			continue;
		}

		int posSpace = parStudies[i].indexOf(' ');
		if (posSpace == -1) {
			%>Retrieve from <%= isIMArchive ? "Archive" : "QR" %>: <%=parStudies[i].substring(2) %> <font color=red>failed</font>
			<%
			continue;
		}

		String device = parStudies[i].substring(2, posSpace);
		String study = parStudies[i].substring(posSpace + 1);
		if (isIMArchive) {
			// Retrieve from Archive
			archiveStudies.setProperty(study, device);
		}
		else {
			// Retrieve from QR Archive
			String startRes = PriorToolbox.startRetrieveFromQR(device, study, is, new IMScriptContext() ) ?
					"started" : "<font color=red>failed</font>";
			%>Retrieve from QR: <%=parStudies[i].substring(2) %> <%= startRes %>
			<%
		}
	}

	if (!archiveStudies.isEmpty()) {
		String startRes = PriorToolbox.startRetrieveFromArchive(is, new IMScriptContext(), archiveStudies) ?
				"started" : "<font color=red>failed</font>";

		for (Enumeration<?> e = archiveStudies.propertyNames(); e.hasMoreElements(); ) {
			String study = (String) e.nextElement();
			%>Retrieve from Archive: <%= study %> <%= startRes %>
			<%
		}
	}

	out.flush();
	Thread.sleep(3000);
%>
</body>
</html>
